/*
 * (c) Peter Mueller, 2008
 *
 * All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden.
 */

/* Command line options: -p ea -t Model:test:A:Class1 -l swift -doxygen -o Testcase testcase.xml   */
/* This file is generated from testcase.xml - do not edit manually  */
/* Generated on: Thu Sep 04 14:23:50 CEST 2014 / version 3.6.7b2 */


//
// test header
//

/**Here is the graph that shows the state machine this function implements\dot
digraph G {
rankdir=TB;
node[fontsize=8 shape=box];
edge[fontsize=8, arrowsize=0.5];
compound=true;
remincross=true;
nodesep=0.3;
ranksep=.4;
"S1"->"S2"[label=<ev30<br ALIGN="LEFT"/>>  color=black, fontname=arial, fontcolor=black]; //S1 S2
"S2"->"S1"[label=<ev30<br ALIGN="LEFT"/>>  color=black, fontname=arial, fontcolor=black]; //S2 S1
"defaultroot"->"S1"[label=<  > style=dotted];

"S1"[fontname=arial, fontsize=8, shape="none",  margin="0",  color=black, label=<
<TABLE CELLBORDER="0" CELLSPACING="0" style="rounded">
<TR>
<TD COLSPAN="2">S1<br ALIGN="LEFT"/> <br ALIGN="LEFT"/><u>Entry</u>:<br ALIGN="LEFT"/>println(&quot;S...<br ALIGN="LEFT"/> <br ALIGN="LEFT"/><u>Exit:</u><br ALIGN="LEFT"/>println(&quot;S...<br ALIGN="LEFT"/><br ALIGN="LEFT"/></TD>
</TR><HR/>
<TR>
<TD><IMG SRC="/var/folders/gb/1zkxp1qn25532041n13_vx480000gn/T/graph_75661627169957796.png"/></TD><VR/>
<TD><IMG SRC="/var/folders/gb/1zkxp1qn25532041n13_vx480000gn/T/graph_6635472844764899147.png"/></TD>
</TR>
</TABLE>>]
"S2"[shape=record, color=black, fontname=arial, style=rounded, label=<{<B>S2</B><br ALIGN="LEFT"/>| <br ALIGN="LEFT"/><u>Entry</u>:<br ALIGN="LEFT"/>println(&quot;E...<br ALIGN="LEFT"/><br ALIGN="LEFT"/>}>];"defaultroot"[label=< >,shape=circle, fontsize=8, fixedsize=true, height=0.2, width=0.2, fillcolor=black, style=filled];
}
\enddot
*/


class Testcase
{

	enum States : Int {
		case S2, S1, R1S11_S2, R1S12, FinalInner, R1S11_S1, R1S11, R2S21, Final, R2S22, SA3, SA32, SA2, SA31, SA1, SB1, SB2, __TESTCASE_LAST_STATE__

		func getNameFromState() -> String {
			switch self {
				case S2:
					return "S2"
				case S1:
					return "S1"
				case R1S11_S2:
					return "R1S11_S2"
				case R1S12:
					return "R1S12"
				case FinalInner:
					return "FinalInner"
				case R1S11_S1:
					return "R1S11_S1"
				case R1S11:
					return "R1S11"
				case R2S21:
					return "R2S21"
				case Final:
					return "Final"
				case R2S22:
					return "R2S22"
				case SA3:
					return "SA3"
				case SA32:
					return "SA32"
				case SA2:
					return "SA2"
				case SA31:
					return "SA31"
				case SA1:
					return "SA1"
				case SB1:
					return "SB1"
				case SB2:
					return "SB2"
				default:
					return "__TESTCASE_LAST_STATE__"
			}
		}
	}

	enum Events : Int {
		case ev30, ev25, ev26, ev28, ev24, TESTCASE_NO_MSG

		func getNameFromEvent() -> String {
			switch self {
				case ev30:
					return "ev30"
				case ev25:
					return "ev25"
				case ev26:
					return "ev26"
				case ev28:
					return "ev28"
				case ev24:
					return "ev24"
				default:
					return "TESTCASE_NO_MSG"
			}
		}
	}

	// State variables
	struct StateVars {
		var stateVar : States = .S1;
		var stateVarRegion1 : States = .R1S12; /* set init state of Region1; */
		var stateVarR1S11 : States = .R1S11_S1; /* set init state of R1S11 */ 
		var stateVarR1S12_R1 : States = .SA1; /* set init state of R1S12_R1; */
		var stateVarSA3 : States = .SA31; /* set init state of SA3 */ 
		var stateVarR1S12_R2 : States = .SB1; /* set init state of R1S12_R2; */
		var stateVarRegion2 : States = .R2S21; /* set init state of Region2; */
	}

	// flag if initialized
	var initialized : Bool = false

	// state vars and copy of state vars
	var stateVars : StateVars = StateVars()
	var stateVarsCopy : StateVars = StateVars()


	// Reset method. Allows to reset the machine into init state
	func reset(){
		//Set copy of vars to default states
		stateVarsCopy = StateVars()
		// Set state vars to default states
		stateVarsCopy = StateVars()

		// Initialize code from default states
		println("S1 Entry");
		println("OnEntry R1S12");
		println("SA1 Entry");
		println("SB1 Entry");
		println("OnEntry R2S21");

	}

	// State machine event handler
	func processEvent( msg : Events, condition : Bool ) -> Int {

		var evConsumed : Int = 0;

	

		//Create copy of statevar
		stateVarsCopy = stateVars

		// action code
		println("Outer test action");


		switch (stateVars.stateVar) {

			case States.S1:
				/* calling region code */
				evConsumed |= TestcaseRegion1(msg, condition : condition);
				evConsumed |= TestcaseRegion2(msg, condition : condition);

				/* Check if event was already processed  */
				if(evConsumed==0){

					if(msg==Events.ev30){
						/* Transition from S1 to S2 */

						/* Exit code for regions in state S1 */
						
						if(stateVars.stateVarRegion1 == .R1S11){

							if(stateVars.stateVarR1S11 == .R1S11_S1){
								println("Exit R1S11_S1");


							}else if(stateVars.stateVarR1S11 == .R1S11_S2){
								println("Exit R1S11_S2");

							}
							

						}else if(stateVars.stateVarRegion1 == .R1S12){

							if(stateVars.stateVarR1S12_R1 == .SA1){
								println("SA1 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA2){
								println("SA2 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA3){

								if(stateVars.stateVarSA3 == .SA31){
									println("SA31 Exit");


								}else if(stateVars.stateVarSA3 == .SA32){
									println("SA32 Exit");

								}
								
							}

							if(stateVars.stateVarR1S12_R2 == .SB1){
								println("SB1 Exit");


							}else if(stateVars.stateVarR1S12_R2 == .SB2){
								println("SB2 Exit");

							}
							println("OnExit R1S12");

						}

						if(stateVars.stateVarRegion2 == .R2S22){
							println("OnExit R2S22");


						}else if(stateVars.stateVarRegion2 == .R2S21){
							println("OnExit R2S21");

						}

						println("S1 Exit");

						/* OnEntry code of state S2 */
						println("Entry S2");

						/* adjust state variables  */
						stateVarsCopy.stateVar = States.S2;
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				}
			break; /* end of case S1  */

			case States.S2:
				if(msg==Events.ev30){
					/* Transition from S2 to S1 */

					/* OnEntry code of state S1 */
					println("S1 Entry");

					/* Entry code for regions in state S1 */
					println("OnEntry R1S12");
					/* Default in entry chain  */
						println("SA1 Entry");
						/* Default in entry chain  */
						stateVarsCopy.stateVarR1S12_R1 = States.SA1;/* Default in entry chain  */
						/* entry chain  */
						if(stateVars.stateVarR1S12_R2 == .SB1){
							println("SB1 Entry");

						}else if(stateVars.stateVarR1S12_R2 == .SB2){
							println("SB2 Entry");

						}
					println("OnEntry R2S21");
					/* Default in entry chain  */
					stateVarsCopy.stateVarRegion2 = States.R2S21;/* Default in entry chain  */


					/* adjust state variables  */
					stateVarsCopy.stateVar = States.S1;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case S2  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */

		// Copy state variables back
		stateVars = stateVarsCopy

		return evConsumed
	} // end processEvent





	/* Region code for state R1S12_R1 */

	func TestcaseR1S12_R1(msg : Events, condition : Bool) -> Int {

		var evConsumed : Int = 0;

		switch (stateVars.stateVarR1S12_R1) {

			case States.SA1:
				if(msg==Events.ev24){
					/* Transition from SA1 to SA2 */
					evConsumed=1;
					/* OnExit code of state SA1 */
					println("SA1 Exit");

					/* OnEntry code of state SA2 */
					println("SA2 Entry");

					/* adjust state variables  */
					stateVarsCopy.stateVarR1S12_R1 = States.SA2;
				}else if(msg==Events.ev25){
					if(false){
						/* Transition from SA1 to SA1 */
						evConsumed=1;
						/* OnExit code of state SA1 */
						println("SA1 Exit");

						/* OnEntry code of state SA1 */
						println("SA1 Entry");

						/* adjust state variables  */
						stateVarsCopy.stateVarR1S12_R1 = States.SA1;
					}else{
						/* Transition from SA1 to SA2 */
						evConsumed=1;
						/* OnExit code of state SA1 */
						println("SA1 Exit");

						/* OnEntry code of state SA2 */
						println("SA2 Entry");

						/* adjust state variables  */
						stateVarsCopy.stateVarR1S12_R1 = States.SA2;
					} /*end of event selection */
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case SA1  */

			case States.SA2:
				if(msg==Events.ev24){
					/* Transition from SA2 to SA3 */
					evConsumed=1;
					/* OnExit code of state SA2 */
					println("SA2 Exit");

					/* OnEntry code of state SA3 */
					println("Entry SA3");
					println("SA31 Entry");
					stateVarsCopy.stateVarR1S12_R1 = States.SA3;/* Default in entry chain  */
					stateVarsCopy.stateVarSA3 = States.SA31;/* Default in entry chain  */

				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case SA2  */

			case States.SA3:

				switch (stateVars.stateVarSA3) {

					case States.SA31:
						/* action code  */
						println("Action SA31");


						if(msg==Events.ev25){
							/* Transition from SA31 to SA32 */
							evConsumed=1;
							/* OnExit code of state SA31 */
							println("SA31 Exit");

							/* OnEntry code of state SA32 */
							println("SA32 Entry");

							/* adjust state variables  */
							stateVarsCopy.stateVarSA3 = States.SA32;
						}else{
							/* Intentionally left blank */
						} /*end of event selection */
					break; /* end of case SA31  */

					case States.SA32:
						/* action code  */
						println("Action SA32");


						if(msg==Events.ev24){
							/* Transition from SA32 to SA2 */
							evConsumed=1;
							/* OnExit code of state SA32 */
							println("SA32 Exit");


							/* OnEntry code of state SA2 */
							println("SA2 Entry");

							/* adjust state variables  */
							stateVarsCopy.stateVarR1S12_R1 = States.SA2;
							stateVarsCopy.stateVarSA3 = States.SA31;
						}else{
							/* Intentionally left blank */
						} /*end of event selection */
					break; /* end of case SA32  */

					default:
						/* Intentionally left blank */
					break;
				} /* end switch SA3 */
			break; /* end of case SA3  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */

		return evConsumed;
	}




	/* Region code for state R1S12_R2 */

	func TestcaseR1S12_R2(msg : Events, condition : Bool) -> Int {

		var evConsumed : Int = 0;

		switch (stateVars.stateVarR1S12_R2) {

			case States.SB1:
				if(msg==Events.ev25){
					/* Transition from SB1 to SB2 */
					evConsumed=1;
					/* OnExit code of state SB1 */
					println("SB1 Exit");

					/* OnEntry code of state SB2 */
					println("SB2 Entry");

					/* adjust state variables  */
					stateVarsCopy.stateVarR1S12_R2 = States.SB2;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case SB1  */

			case States.SB2:
				if(msg==Events.ev25){
					/* Transition from SB2 to SB1 */
					evConsumed=1;
					/* OnExit code of state SB2 */
					println("SB2 Exit");

					/* OnEntry code of state SB1 */
					println("SB1 Entry");

					/* adjust state variables  */
					stateVarsCopy.stateVarR1S12_R2 = States.SB1;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case SB2  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */

		return evConsumed;
	}




	/* Region code for state Region1 */

	func TestcaseRegion1(msg : Events, condition : Bool) -> Int {

		var evConsumed : Int = 0;

		switch (stateVars.stateVarRegion1) {

			case States.R1S11:

				switch (stateVars.stateVarR1S11) {

					case States.R1S11_S1:
						if(msg==Events.ev25){
							/* Transition from R1S11_S1 to R1S12 */
							evConsumed=1;
							/* OnExit code of state R1S11_S1 */
							println("Exit R1S11_S1");


							/* OnEntry code of state R1S12 */
							println("OnEntry R1S12");

							/* Entry code for regions in state R1S12 */
							println("SA1 Entry");
							/* Default in entry chain  */
							stateVarsCopy.stateVarR1S12_R1 = States.SA1;/* Default in entry chain  */
							/* entry chain  */
							if(stateVars.stateVarR1S12_R2 == .SB1){
								println("SB1 Entry");

							}else if(stateVars.stateVarR1S12_R2 == .SB2){
								println("SB2 Entry");

							}


							/* adjust state variables  */
							stateVarsCopy.stateVarR1S11 = States.R1S11_S1;
							stateVarsCopy.stateVarRegion1 = States.R1S12;
						}else if(msg==Events.ev28){
							/* Transition from R1S11_S1 to FinalInner */
							evConsumed=1;
							/* OnExit code of state R1S11_S1 */
							println("Exit R1S11_S1");


							/* adjust state variables  */
							stateVarsCopy.stateVarR1S11 = States.FinalInner;
						}else{
							/* Intentionally left blank */
						} /*end of event selection */
					break; /* end of case R1S11_S1  */

					case States.R1S11_S2:
						if(msg==Events.ev28){
							if(1==2){
								/* Transition from R1S11_S2 to R1S11_S1 */
								evConsumed=1;
								/* OnExit code of state R1S11_S2 */
								println("Exit R1S11_S2");

								/* OnEntry code of state R1S11_S1 */
								println("Entry R1S11_S1");

								/* adjust state variables  */
								stateVarsCopy.stateVarR1S11 = States.R1S11_S1;
							}else if(true){
								/* Transition from R1S11_S2 to R1S11_S1 */
								evConsumed=1;
								/* OnExit code of state R1S11_S2 */
								println("Exit R1S11_S2");

								/* OnEntry code of state R1S11_S1 */
								println("Entry R1S11_S1");

								/* adjust state variables  */
								stateVarsCopy.stateVarR1S11 = States.R1S11_S1;
							}else{
								/* Transition from R1S11_S2 to FinalInner */
								evConsumed=1;
								/* OnExit code of state R1S11_S2 */
								println("Exit R1S11_S2");


								/* adjust state variables  */
								stateVarsCopy.stateVarR1S11 = States.FinalInner;
							} /*end of event selection */
						}else{
							/* Intentionally left blank */
						} /*end of event selection */
					break; /* end of case R1S11_S2  */

					case States.FinalInner:
					break; /* end of case FinalInner  */

					default:
						/* Intentionally left blank */
					break;
				} /* end switch R1S11 */
			break; /* end of case R1S11  */

			case States.R1S12:
				/* action code  */
				println("Action R1S12");


				/* calling region code */
				evConsumed |= TestcaseR1S12_R1(msg, condition : condition);
				evConsumed |= TestcaseR1S12_R2(msg, condition : condition);

				/* Check if event was already processed  */
				if(evConsumed==0){

					if(msg==Events.ev26){
						if(false){
							/* Transition from R1S12 to R1S11_S2 */
							evConsumed=1;

							/* Exit code for regions in state R1S12 */
						
							if(stateVars.stateVarR1S12_R1 == .SA1){
								println("SA1 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA2){
								println("SA2 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA3){

								if(stateVars.stateVarSA3 == .SA31){
									println("SA31 Exit");


								}else if(stateVars.stateVarSA3 == .SA32){
									println("SA32 Exit");

								}
								
							}

							if(stateVars.stateVarR1S12_R2 == .SB1){
								println("SB1 Exit");


							}else if(stateVars.stateVarR1S12_R2 == .SB2){
								println("SB2 Exit");

							}

							println("OnExit R1S12");


							/* OnEntry code of state R1S11_S2 */
							println("Entry R1S11_S2");

							/* adjust state variables  */
							stateVarsCopy.stateVarR1S11 = States.R1S11_S2;
							stateVarsCopy.stateVarRegion1 = States.R1S11;
						}else{
							/* Transition from R1S12 to R1S12 */
							evConsumed=1;

							/* Exit code for regions in state R1S12 */
						
							if(stateVars.stateVarR1S12_R1 == .SA1){
								println("SA1 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA2){
								println("SA2 Exit");


							}else if(stateVars.stateVarR1S12_R1 == .SA3){

								if(stateVars.stateVarSA3 == .SA31){
									println("SA31 Exit");


								}else if(stateVars.stateVarSA3 == .SA32){
									println("SA32 Exit");

								}
								
							}

							if(stateVars.stateVarR1S12_R2 == .SB1){
								println("SB1 Exit");


							}else if(stateVars.stateVarR1S12_R2 == .SB2){
								println("SB2 Exit");

							}

							println("OnExit R1S12");

							/* OnEntry code of state R1S12 */
							println("OnEntry R1S12");

							/* Entry code for regions in state R1S12 */
							println("SA1 Entry");
							/* Default in entry chain  */
							stateVarsCopy.stateVarR1S12_R1 = States.SA1;/* Default in entry chain  */
							/* entry chain  */
							if(stateVars.stateVarR1S12_R2 == .SB1){
								println("SB1 Entry");

							}else if(stateVars.stateVarR1S12_R2 == .SB2){
								println("SB2 Entry");

							}


							/* adjust state variables  */
							stateVarsCopy.stateVarRegion1 = States.R1S12;
						} /*end of event selection */
					}else if(msg==Events.ev28){
						/* Transition from R1S12 to R1S11 */
						evConsumed=1;

						/* Exit code for regions in state R1S12 */
						
						if(stateVars.stateVarR1S12_R1 == .SA1){
							println("SA1 Exit");


						}else if(stateVars.stateVarR1S12_R1 == .SA2){
							println("SA2 Exit");


						}else if(stateVars.stateVarR1S12_R1 == .SA3){

							if(stateVars.stateVarSA3 == .SA31){
								println("SA31 Exit");


							}else if(stateVars.stateVarSA3 == .SA32){
								println("SA32 Exit");

							}
							
						}

						if(stateVars.stateVarR1S12_R2 == .SB1){
							println("SB1 Exit");


						}else if(stateVars.stateVarR1S12_R2 == .SB2){
							println("SB2 Exit");

						}

						println("OnExit R1S12");

						println("Entry R1S11_S1");
						stateVarsCopy.stateVarRegion1 = States.R1S11;/* Default in entry chain  */
						stateVarsCopy.stateVarR1S11 = States.R1S11_S1;/* Default in entry chain  */

					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				}
			break; /* end of case R1S12  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */

		return evConsumed;
	}




	/* Region code for state Region2 */

	func TestcaseRegion2(msg : Events, condition : Bool) -> Int {

		var evConsumed : Int = 0;

		switch (stateVars.stateVarRegion2) {

			case States.R2S22:
				if(msg==Events.ev24){
					/* Transition from R2S22 to Final */
					evConsumed=1;
					/* OnExit code of state R2S22 */
					println("OnExit R2S22");

					/* Action code for transition  */
					println("ev24 to final");


					/* adjust state variables  */
					stateVarsCopy.stateVarRegion2 = States.Final;
				}else if(msg==Events.ev25){
					/* Transition from R2S22 to R2S21 */
					evConsumed=1;
					/* OnExit code of state R2S22 */
					println("OnExit R2S22");

					/* OnEntry code of state R2S21 */
					println("OnEntry R2S21");

					/* adjust state variables  */
					stateVarsCopy.stateVarRegion2 = States.R2S21;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case R2S22  */

			case States.R2S21:
				if(msg==Events.ev25){
					/* Transition from R2S21 to R2S22 */
					evConsumed=1;
					/* OnExit code of state R2S21 */
					println("OnExit R2S21");

					/* OnEntry code of state R2S22 */
					println("OnEntry R2S22");

					/* adjust state variables  */
					stateVarsCopy.stateVarRegion2 = States.R2S22;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case R2S21  */

			case States.Final:
			break; /* end of case Final  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */

		return evConsumed;
	}


}
